<template lang="pug">
.flex.q-gutter-md.full-width.q-mt-none
	q-card.my-card(v-for="(item, index) in model", :key="item.ingredient.id")
		q-img(
			v-if="item.ingredient.visual"
			ratio="1.5",
			fit="contain"
			:src="item.ingredient.visual.lowUrl"
		)
			q-icon.absolute.all-pointer-events.cursor-pointer(
				size="32px"
				name="highlight_off"
				color="red"
				style="top: 8px; right: 8px"
				@click="removeItem(index)"
			)
				ui-tooltip Удалить
		q-card-section
			.text-subtitle1 {{ item.ingredient.name }}
		q-card-section.q-pt-none
			ui-input-text(
				v-model.trim="item.brutto",
				label="Брутто",
				type="number"
				required,
				suffix="грамм"
			)
			.q-mt-md
				ui-input-text(
					v-model.trim="item.netto",
					label="Нетто",
					type="number"
					required,
					suffix="грамм"
				)

	q-card.my-card.cursor-pointer.flex.flex-center(
		v-ripple
		@click="addDialogModel = true"
		v-if="!isMaxCount"
	)
		q-card-section.text-center
			q-icon(
				size="80px"
				name="queue"
				color="grey"
			)
			.text-subtitle1.q-mt-sm Добавить#[br]ингредиент

q-dialog(v-model="addDialogModel" persistent)
	q-card(
		style="width: 300px"
	)
		q-card-section
			.text-h6 Добавление ингредиента

		q-card-section.q-pt-none
			ui-input-autocomplete(
				v-model="searchModel"
				label="Ингредиент"
				required
				@onSearch="onSearch"
				:options="searchItems"
			)
				template(v-slot:no-option)
					q-item
						q-item-section.text-grey Ингредиенты не найдены

		q-card-actions(align="right" class="text-primary")
			q-btn(flat label="Отмена" v-close-popup)
			q-btn(flat label="Добавить" :disable="!searchModel" @click="addItem")

</template>

<script lang="ts">
	import { computed, defineComponent, reactive, ref } from 'vue'
	import { IIngredient, ITechMapUnit, FilterOptionsQuery } from '@/plugins/utils/types'
	import UiInputText from '@/components/ui/UiInputText.vue'
	import UiInputAutocomplete from '@/components/ui/UiInputAutocomplete.vue'
	import UiTooltip from '@/components/ui/UiTooltip.vue'
	import { client } from '@/plugins/api'

	export default defineComponent({
		name: 'CollectionIngredient',

		components: {
			UiInputText,
			UiInputAutocomplete,
			UiTooltip,
		},

		props: {
			modelValue: {
				type: [Object, Array],
				default: () => [],
			},
			max: {
				type: Number,
				default: Infinity,
			},
			label: {
				type: String,
				default: 'Ингредиенты',
			},
			rules: {
				type: Array,
				default: () => [],
			},
		},

		emits: ['update:modelValue'],

		setup(props, { emit }) {
			const model = computed({
				get: (): ITechMapUnit[] => {
					return props.modelValue
				},
				set: (val) => {
					emit('update:modelValue', val)
				},
			})

			const isMaxCount = computed(() => model.value.length >= props.max)

			const addDialogModel = ref(false)

			const searchModel = ref<IIngredient>()
			const searchItems = ref([])

			const addedIngredients = computed(() => model.value.map((item) => item.ingredient.id))

			return {
				model,
				addDialogModel,

				searchModel,
				searchItems,

				isMaxCount,

				removeItem(idx: number) {
					model.value = [...model.value.slice(0, idx), ...model.value.slice(idx + 1)]
				},
				async addItem() {
					await model.value.push({
						brutto: 0,
						netto: 0,
						ingredient: JSON.parse(JSON.stringify(searchModel.value)),
					})
					searchModel.value = undefined
					addDialogModel.value = false
				},
				async onSearch(search: string, update: any) {
					const values = await client.ingredients.getAll(
						new FilterOptionsQuery({
							size: 50,
							search,
						}),
					)
					update(() => {
						searchItems.value = values.items.filter((item: IIngredient) => {
							return !addedIngredients.value.includes(item.id)
						})
					})
				},
			}
		},
	})
</script>

<style lang="scss" scoped>
	.my-card {
		width: 100%;
		max-width: 222px;
	}
</style>
